dofile("sys/lua/WeaponPlacer/includes/init.lua");	-- Includes all needed data
dofile("sys/lua/WeaponPlacer/includes/menu.lua");	-- Function for drawing weapon menus
dofile("sys/lua/WeaponPlacer/includes/position.lua") -- functions to convert positions

-- ### Define Hooks ### --

function DarkByte.wp.hook_say(id, txt)
	txt = txt:lower();	-- format text
	if ( txt == "weapons" ) then
		DrawWeaponMenu(id);	-- Display the menu
		return 1;
	end
end

function DarkByte.wp.hook_menu(id, title, b)
	if ( string.sub(title, 1, 19) == "Weapons Menu Page: " ) then
		local pageid = DarkByte.wp.data[id].pageid * 5 + b - 4;
		if ( b < 7 and DarkByte.wp.data.wpnEnabled[pageid] ) then
			if ( player(id, "money") >= DarkByte.wp.data.wpnPrices[pageid-1] ) then
				DarkByte.wp.data[id].selectedWeapon = DarkByte.wp.data.wpnID[pageid]-1;

				if ( DarkByte.wp.data[id].selectedWeapon == 9 ) then -- Five-Seven fix
					DarkByte.wp.data[id].selectedWeapon = 6;
				end

				if ( DarkByte.wp.data[id].selectedWeapon == 99 ) then -- Portal Gun fix
					DarkByte.wp.data[id].selectedWeapon = 88;
				end

				parse("setmoney "..id.." "..player(id, "money")-DarkByte.wp.data.wpnPrices[pageid-1]);
			else
				msg2(id, "255000000Can not spawn item - Insufficient funds@C");
			end
		elseif ( b == 8 ) then
			DarkByte.wp.data[id].pageid = DarkByte.wp.data[id].pageid + 1;
			if ( DarkByte.wp.data[id].pageid > 14 ) then
				DarkByte.wp.data[id].pageid = 1;
			end
			DrawWeaponMenu(id);
		elseif ( b == 9 ) then
			DarkByte.wp.data[id].pageid = DarkByte.wp.data[id].pageid - 1;
			if ( DarkByte.wp.data[id].pageid < 1 ) then
				DarkByte.wp.data[id].pageid = 14;
			end
			DrawWeaponMenu(id);
		end
	end
end

function DarkByte.wp.hook_ms100()
	reqcld(0, 2);

	for i = 1, 32, 1 do
		if ( DarkByte.wp.data[i].selectedWeapon == 0 ) then
			if ( DarkByte.wp.data[i].imgid ~= -1 ) then
				freeimage(DarkByte.wp.data[i].imgid);
				DarkByte.wp.data[i].imgid = -1;
			end
		else
			if ( DarkByte.wp.data[i].imgid == -1 ) then
				DarkByte.wp.data[i].imgid = image("gfx/hilight.bmp", 0, 0, 0, 0);
				imagealpha(DarkByte.wp.data[i].imgid, 0.5);
				imagecolor(DarkByte.wp.data[i].imgid, 188, 210, 238);
			end

			local x, y = DarkByte.wp.data[i].cursorx, DarkByte.wp.data[i].cursory;
			x,y = NearestWalkable(x, y);
			x, y = TilePos(x, y);
			x, y = x*32+16, y*32+16;

			imagepos(DarkByte.wp.data[i].imgid, x, y, 0);
		end
	end
end

function DarkByte.wp.hook_clientdata(id, mode, x, y)
	if ( mode == 2 ) then
		DarkByte.wp.data[id].cursorx = x;
		DarkByte.wp.data[id].cursory = y;
	end
end

function DarkByte.wp.hook_attack(id)
	if ( DarkByte.wp.data[id].selectedWeapon > 0 ) then
		local x, y = DarkByte.wp.data[id].cursorx, DarkByte.wp.data[id].cursory;
		x,y = NearestWalkable(x,y);
		x, y = TilePos(x, y);
		parse("spawnitem "..DarkByte.wp.data[id].selectedWeapon.." "..x.." "..y);
		DarkByte.wp.data[id].selectedWeapon = 0;
	end
end

-- ### Add Hooks ### --

addhook("say", "DarkByte.wp.hook_say");
addhook("menu", "DarkByte.wp.hook_menu");
addhook("ms100", "DarkByte.wp.hook_ms100");
addhook("clientdata", "DarkByte.wp.hook_clientdata");
addhook("attack", "DarkByte.wp.hook_attack");
